

module DE1_SoC_Computer (
	////////////////////////////////////
	// FPGA Pins
	////////////////////////////////////

	// Clock pins
	CLOCK_50,
	CLOCK2_50,
	CLOCK3_50,
	CLOCK4_50,

	// ADC
	ADC_CS_N,
	ADC_DIN,
	ADC_DOUT,
	ADC_SCLK,

	// Audio
	AUD_ADCDAT,
	AUD_ADCLRCK,
	AUD_BCLK,
	AUD_DACDAT,
	AUD_DACLRCK,
	AUD_XCK,

	// SDRAM
	DRAM_ADDR,
	DRAM_BA,
	DRAM_CAS_N,
	DRAM_CKE,
	DRAM_CLK,
	DRAM_CS_N,
	DRAM_DQ,
	DRAM_LDQM,
	DRAM_RAS_N,
	DRAM_UDQM,
	DRAM_WE_N,

	// I2C Bus for Configuration of the Audio and Video-In Chips
	FPGA_I2C_SCLK,
	FPGA_I2C_SDAT,

	// 40-Pin Headers
	GPIO_0,
	GPIO_1,
	
	// Seven Segment Displays
	HEX0,
	HEX1,
	HEX2,
	HEX3,
	HEX4,
	HEX5,

	// IR
	IRDA_RXD,
	IRDA_TXD,

	// Pushbuttons
	KEY,

	// LEDs
	LEDR,

	// PS2 Ports
	PS2_CLK,
	PS2_DAT,
	
	PS2_CLK2,
	PS2_DAT2,

	// Slider Switches
	SW,

	// Video-In
	TD_CLK27,
	TD_DATA,
	TD_HS,
	TD_RESET_N,
	TD_VS,

	// VGA
	VGA_B,
	VGA_BLANK_N,
	VGA_CLK,
	VGA_G,
	VGA_HS,
	VGA_R,
	VGA_SYNC_N,
	VGA_VS,

	////////////////////////////////////
	// HPS Pins
	////////////////////////////////////
	
	// DDR3 SDRAM
	HPS_DDR3_ADDR,
	HPS_DDR3_BA,
	HPS_DDR3_CAS_N,
	HPS_DDR3_CKE,
	HPS_DDR3_CK_N,
	HPS_DDR3_CK_P,
	HPS_DDR3_CS_N,
	HPS_DDR3_DM,
	HPS_DDR3_DQ,
	HPS_DDR3_DQS_N,
	HPS_DDR3_DQS_P,
	HPS_DDR3_ODT,
	HPS_DDR3_RAS_N,
	HPS_DDR3_RESET_N,
	HPS_DDR3_RZQ,
	HPS_DDR3_WE_N,

	// Ethernet
	HPS_ENET_GTX_CLK,
	HPS_ENET_INT_N,
	HPS_ENET_MDC,
	HPS_ENET_MDIO,
	HPS_ENET_RX_CLK,
	HPS_ENET_RX_DATA,
	HPS_ENET_RX_DV,
	HPS_ENET_TX_DATA,
	HPS_ENET_TX_EN,

	// Flash
	HPS_FLASH_DATA,
	HPS_FLASH_DCLK,
	HPS_FLASH_NCSO,

	// Accelerometer
	HPS_GSENSOR_INT,
		
	// General Purpose I/O
	HPS_GPIO,
		
	// I2C
	HPS_I2C_CONTROL,
	HPS_I2C1_SCLK,
	HPS_I2C1_SDAT,
	HPS_I2C2_SCLK,
	HPS_I2C2_SDAT,

	// Pushbutton
	HPS_KEY,

	// LED
	HPS_LED,
		
	// SD Card
	HPS_SD_CLK,
	HPS_SD_CMD,
	HPS_SD_DATA,

	// SPI
	HPS_SPIM_CLK,
	HPS_SPIM_MISO,
	HPS_SPIM_MOSI,
	HPS_SPIM_SS,

	// UART
	HPS_UART_RX,
	HPS_UART_TX,

	// USB
	HPS_CONV_USB_N,
	HPS_USB_CLKOUT,
	HPS_USB_DATA,
	HPS_USB_DIR,
	HPS_USB_NXT,
	HPS_USB_STP
);

//=======================================================
//  PARAMETER declarations
//=======================================================


//=======================================================
//  PORT declarations
//=======================================================

////////////////////////////////////
// FPGA Pins
////////////////////////////////////

// Clock pins
input						CLOCK_50;
input						CLOCK2_50;
input						CLOCK3_50;
input						CLOCK4_50;

// ADC
inout						ADC_CS_N;
output					ADC_DIN;
input						ADC_DOUT;
output					ADC_SCLK;

// Audio
input						AUD_ADCDAT;
inout						AUD_ADCLRCK;
inout						AUD_BCLK;
output					AUD_DACDAT;
inout						AUD_DACLRCK;
output					AUD_XCK;

// SDRAM
output 		[12: 0]	DRAM_ADDR;
output		[ 1: 0]	DRAM_BA;
output					DRAM_CAS_N;
output					DRAM_CKE;
output					DRAM_CLK;
output					DRAM_CS_N;
inout			[15: 0]	DRAM_DQ;
output					DRAM_LDQM;
output					DRAM_RAS_N;
output					DRAM_UDQM;
output					DRAM_WE_N;

// I2C Bus for Configuration of the Audio and Video-In Chips
output					FPGA_I2C_SCLK;
inout						FPGA_I2C_SDAT;

// 40-pin headers
inout			[35: 0]	GPIO_0;
inout			[35: 0]	GPIO_1;

// Seven Segment Displays
output		[ 6: 0]	HEX0;
output		[ 6: 0]	HEX1;
output		[ 6: 0]	HEX2;
output		[ 6: 0]	HEX3;
output		[ 6: 0]	HEX4;
output		[ 6: 0]	HEX5;

// IR
input						IRDA_RXD;
output					IRDA_TXD;

// Pushbuttons
input			[ 3: 0]	KEY;

// LEDs
output		[ 9: 0]	LEDR;

// PS2 Ports
inout						PS2_CLK;
inout						PS2_DAT;

inout						PS2_CLK2;
inout						PS2_DAT2;

// Slider Switches
input			[ 9: 0]	SW;

// Video-In
input						TD_CLK27;
input			[ 7: 0]	TD_DATA;
input						TD_HS;
output					TD_RESET_N;
input						TD_VS;

// VGA
output		[ 7: 0]	VGA_B;
output					VGA_BLANK_N;
output					VGA_CLK;
output		[ 7: 0]	VGA_G;
output					VGA_HS;
output		[ 7: 0]	VGA_R;
output					VGA_SYNC_N;
output					VGA_VS;



////////////////////////////////////
// HPS Pins
////////////////////////////////////
	
// DDR3 SDRAM
output		[14: 0]	HPS_DDR3_ADDR;
output		[ 2: 0]  HPS_DDR3_BA;
output					HPS_DDR3_CAS_N;
output					HPS_DDR3_CKE;
output					HPS_DDR3_CK_N;
output					HPS_DDR3_CK_P;
output					HPS_DDR3_CS_N;
output		[ 3: 0]	HPS_DDR3_DM;
inout			[31: 0]	HPS_DDR3_DQ;
inout			[ 3: 0]	HPS_DDR3_DQS_N;
inout			[ 3: 0]	HPS_DDR3_DQS_P;
output					HPS_DDR3_ODT;
output					HPS_DDR3_RAS_N;
output					HPS_DDR3_RESET_N;
input						HPS_DDR3_RZQ;
output					HPS_DDR3_WE_N;

// Ethernet
output					HPS_ENET_GTX_CLK;
inout						HPS_ENET_INT_N;
output					HPS_ENET_MDC;
inout						HPS_ENET_MDIO;
input						HPS_ENET_RX_CLK;
input			[ 3: 0]	HPS_ENET_RX_DATA;
input						HPS_ENET_RX_DV;
output		[ 3: 0]	HPS_ENET_TX_DATA;
output					HPS_ENET_TX_EN;

// Flash
inout			[ 3: 0]	HPS_FLASH_DATA;
output					HPS_FLASH_DCLK;
output					HPS_FLASH_NCSO;

// Accelerometer
inout						HPS_GSENSOR_INT;

// General Purpose I/O
inout			[ 1: 0]	HPS_GPIO;

// I2C
inout						HPS_I2C_CONTROL;
inout						HPS_I2C1_SCLK;
inout						HPS_I2C1_SDAT;
inout						HPS_I2C2_SCLK;
inout						HPS_I2C2_SDAT;

// Pushbutton
inout						HPS_KEY;

// LED
inout						HPS_LED;

// SD Card
output					HPS_SD_CLK;
inout						HPS_SD_CMD;
inout			[ 3: 0]	HPS_SD_DATA;

// SPI
output					HPS_SPIM_CLK;
input						HPS_SPIM_MISO;
output					HPS_SPIM_MOSI;
inout						HPS_SPIM_SS;

// UART
input						HPS_UART_RX;
output					HPS_UART_TX;

// USB
inout						HPS_CONV_USB_N;
input						HPS_USB_CLKOUT;
inout			[ 7: 0]	HPS_USB_DATA;
input						HPS_USB_DIR;
input						HPS_USB_NXT;
output					HPS_USB_STP;

//=======================================================
//  REG/WIRE declarations
//=======================================================

wire			[15: 0]	hex3_hex0;
//wire			[15: 0]	hex5_hex4;

//assign HEX0 = ~hex3_hex0[ 6: 0]; // hex3_hex0[ 6: 0]; 
//assign HEX1 = ~hex3_hex0[14: 8];
//assign HEX2 = ~hex3_hex0[22:16];
//assign HEX3 = ~hex3_hex0[30:24];
assign HEX4 = 7'b1111111;
assign HEX5 = 7'b1111111;

HexDigit Digit0(HEX0, hex3_hex0[3:0]);
HexDigit Digit1(HEX1, hex3_hex0[7:4]);
HexDigit Digit2(HEX2, hex3_hex0[11:8]);
HexDigit Digit3(HEX3, hex3_hex0[15:12]);

//wire [31:0] s1_readdata ;
//wire [31:0] s1_writedata ;
//wire [9:0] s1_address;
//wire s1_write;
//wire s1_clken = 1'b1;
//wire s1_chipselect = 1'b1;
reg signed [31:0] s_writedata [9:0];
wire signed [31:0] s_readdata [9:0];
reg [9:0] s_address[9:0];
reg s_write [9:0];

wire [1:0] sel;

assign sel = SW[2:1];

genvar j;

generate 

for(j=0;j<10;j=j+1) begin : myloop
reg [3:0] sram_state = 4'd0;

reg signed[26:0] xout, yout, zout, xcur, ycur, zcur;

wire signed[26:0] xn, yn, zn;

reg[31:0] i = 32'd0;
reg[9:0] iter = 10'd0;
reg signed[31:0] data_buffer;

matrixmul mulA(
	.xo(xcur),
	.yo(ycur),
	.zo(zcur),
	.sin({12'd0,15'b000001000111011}), //{12'd0,1'b1,14'd0}
	.cos({12'd0,15'b111111111111011}), //{12'd0,15'b110111011011001}
	.sel(sel),
	.xn(xn),
	.yn(yn),
	.zn(zn)
);

always @ (posedge CLOCK_50) begin

	
	sram_state <= sram_state;
	xcur <= xcur;
	ycur <= ycur;
	zcur <= zcur;
	xout <= xout;
	yout <= yout;
	zout <= zout;
	s_address[j] <= s_address[j];
	s_write[j] <= s_write[j] ;
	i<=i;
	iter<=iter;
	data_buffer<=data_buffer;
	s_writedata[j]<= s_writedata[j];

	if (sram_state == 4'd0) begin
		s_address[j] <= 10'd0 ;
		s_write[j] <= 1'b0 ;
		sram_state <= 4'd1;
		i<=32'd0;
		iter<=10'd0;
	end

	if (sram_state == 4'd1) begin 
		sram_state <= 4'd2 ;
	end



	if (sram_state == 4'd2) begin 
		data_buffer <= s_readdata[j] ;
		s_write[j] <= 1'b0 ;
		sram_state <= 4'd3 ;
	end

	if (sram_state == 4'd3) begin
		if (data_buffer == 32'd_1) begin
			s_address[j] <= 10'd1 ;
			//s1_writedata <= (data_buffer + 32'd_1) ;
			sram_state <= 4'd4;
		end else begin
			sram_state <= 4'd0;
		end
	end

	if (sram_state == 4'd4) begin 
		
		if(iter<10'd903) begin
			if(i==32'd0)begin
				s_address[j] <= iter + 10'd1 ; //1
				s_write[j] <= 1'b0 ;
				i<=i+32'd1;
			end else if (i == 32'd1)begin
				xcur <= {s_readdata[j][31],s_readdata[j][25:0]} ;
				i <= i + 32'd1 ;
				s_write[j] <= 1'b0 ;
				s_address[j] <= s_address[j] + 10'd1 ;//2
			end else if (i == 32'd2)begin
				ycur <= {s_readdata[j][31],s_readdata[j][25:0]} ;
				s_write[j] <= 1'b0 ;
				i <= i + 32'd1 ;
				s_address[j] <= s_address[j] + 10'd1 ; //3
			end else if (i == 32'd3)begin
				zcur <= {s_readdata[j][31],s_readdata[j][25:0]} ;
				s_write[j] <= 1'b0 ;
				i<=i+32'd1;
				s_address[j] <= s_address[j] ;//3
//			end else if (i == 32'd4)begin
//				zcur <= {s1_readdata[31],s1_readdata[25:0]};
//				s1_write <= 1'b0 ;
//				i<=i+32'd1;
//				s1_address <= s1_address;//3
			end else if (i == 32'd4)begin
				xout <= xn;
				yout <= yn;
				zout <= zn;
				s_writedata[j] <= {{5{xn[26]}},xn} ;
				s_write[j] <= 1'b1 ;
				i<=i+32'd1;
				s_address[j] <= s_address[j] - 10'd2 ; //1
			end else if (i == 32'd5)begin
				xout <= xout;
				yout <= yout;
				zout <= zout;
				s_writedata[j] <= {{5{yout[26]}},yout}  ;
				s_write[j] <= 1'b1 ;
				i<=i+32'd1;
				s_address[j] <= s_address[j] + 10'd1 ; //1
			end else if (i == 32'd6)begin
				xout <= xout;
				yout <= yout;
				zout <= zout;
				s_writedata[j] <= {{5{zout[26]}},zout} ;
				s_write[j] <= 1'b1 ;
				i<=32'd0;
				iter <= iter + 10'd3;
				s_address[j] <= s_address[j] + 10'd1 ; //1

			end else begin
				i<=32'd0;
			end

		end else begin
			iter <= 10'd0;
			sram_state<=4'd0;
			s_address[j]<=10'd0;
			s_write[j]<=1'b1;
			s_writedata[j]<=32'd0;
		end

	end
end
end
endgenerate
//=======================================================
//  Structural coding
//=======================================================

Computer_System The_System (
	////////////////////////////////////
	// FPGA Side
	////////////////////////////////////

	// Global signals
	.system_pll_ref_clk_clk					(CLOCK_50),
	.system_pll_ref_reset_reset			(1'b0),

	// AV Config
	.av_config_SCLK							(FPGA_I2C_SCLK),
	.av_config_SDAT							(FPGA_I2C_SDAT),

	// VGA Subsystem
	.vga_pll_ref_clk_clk 					(CLOCK2_50),
	.vga_pll_ref_reset_reset				(1'b0),
	.vga_CLK										(VGA_CLK),
	.vga_BLANK									(VGA_BLANK_N),
	.vga_SYNC									(VGA_SYNC_N),
	.vga_HS										(VGA_HS),
	.vga_VS										(VGA_VS),
	.vga_R										(VGA_R),
	.vga_G										(VGA_G),
	.vga_B										(VGA_B),
	
	// SDRAM
	.sdram_clk_clk								(DRAM_CLK),
   .sdram_addr									(DRAM_ADDR),
	.sdram_ba									(DRAM_BA),
	.sdram_cas_n								(DRAM_CAS_N),
	.sdram_cke									(DRAM_CKE),
	.sdram_cs_n									(DRAM_CS_N),
	.sdram_dq									(DRAM_DQ),
	.sdram_dqm									({DRAM_UDQM,DRAM_LDQM}),
	.sdram_ras_n								(DRAM_RAS_N),
	.sdram_we_n									(DRAM_WE_N),
	
	////////////////////////////////////
	// HPS Side
	////////////////////////////////////
	// DDR3 SDRAM
	.memory_mem_a			(HPS_DDR3_ADDR),
	.memory_mem_ba			(HPS_DDR3_BA),
	.memory_mem_ck			(HPS_DDR3_CK_P),
	.memory_mem_ck_n		(HPS_DDR3_CK_N),
	.memory_mem_cke		(HPS_DDR3_CKE),
	.memory_mem_cs_n		(HPS_DDR3_CS_N),
	.memory_mem_ras_n		(HPS_DDR3_RAS_N),
	.memory_mem_cas_n		(HPS_DDR3_CAS_N),
	.memory_mem_we_n		(HPS_DDR3_WE_N),
	.memory_mem_reset_n	(HPS_DDR3_RESET_N),
	.memory_mem_dq			(HPS_DDR3_DQ),
	.memory_mem_dqs		(HPS_DDR3_DQS_P),
	.memory_mem_dqs_n		(HPS_DDR3_DQS_N),
	.memory_mem_odt		(HPS_DDR3_ODT),
	.memory_mem_dm			(HPS_DDR3_DM),
	.memory_oct_rzqin		(HPS_DDR3_RZQ),
	
	.onchip_memory1_0_s1_address(s_address[0]),     //  onchip_memory2_0_s1.address
		.onchip_memory1_0_s1_clken(1'b1),       //                     .clken
		.onchip_memory1_0_s1_chipselect(1'b1),  //                     .chipselect
		.onchip_memory1_0_s1_write(s_write[0]),       //                     .write
		.onchip_memory1_0_s1_readdata(s_readdata[0]),    //                     .readdata
		.onchip_memory1_0_s1_writedata(s_writedata[0]),   //                     .writedata
		.onchip_memory1_0_s1_byteenable(4'b_1111),
	
	.onchip_memory2_0_s1_address(s_address[1]),     //  onchip_memory2_0_s1.address
		.onchip_memory2_0_s1_clken(1'b1),       //                     .clken
		.onchip_memory2_0_s1_chipselect(1'b1),  //                     .chipselect
		.onchip_memory2_0_s1_write(s_write[1]),       //                     .write
		.onchip_memory2_0_s1_readdata(s_readdata[1]),    //                     .readdata
		.onchip_memory2_0_s1_writedata(s_writedata[1]),   //                     .writedata
		.onchip_memory2_0_s1_byteenable(4'b_1111),
		
	.onchip_memory3_0_s1_address(s_address[2]),     //  onchip_memory2_0_s1.address
		.onchip_memory3_0_s1_clken(1'b1),       //                     .clken
		.onchip_memory3_0_s1_chipselect(1'b1),  //                     .chipselect
		.onchip_memory3_0_s1_write(s_write[2]),       //                     .write
		.onchip_memory3_0_s1_readdata(s_readdata[2]),    //                     .readdata
		.onchip_memory3_0_s1_writedata(s_writedata[2]),   //                     .writedata
		.onchip_memory3_0_s1_byteenable(4'b_1111),
		
	.onchip_memory4_0_s1_address(s_address[3]),     //  onchip_memory2_0_s1.address
		.onchip_memory4_0_s1_clken(1'b1),       //                     .clken
		.onchip_memory4_0_s1_chipselect(1'b1),  //                     .chipselect
		.onchip_memory4_0_s1_write(s_write[3]),       //                     .write
		.onchip_memory4_0_s1_readdata(s_readdata[3]),    //                     .readdata
		.onchip_memory4_0_s1_writedata(s_writedata[3]),   //                     .writedata
		.onchip_memory4_0_s1_byteenable(4'b_1111),
		
	.onchip_memory5_0_s1_address(s_address[4]),     //  onchip_memory2_0_s1.address
		.onchip_memory5_0_s1_clken(1'b1),       //                     .clken
		.onchip_memory5_0_s1_chipselect(1'b1),  //                     .chipselect
		.onchip_memory5_0_s1_write(s_write[4]),       //                     .write
		.onchip_memory5_0_s1_readdata(s_readdata[4]),    //                     .readdata
		.onchip_memory5_0_s1_writedata(s_writedata[4]),   //                     .writedata
		.onchip_memory5_0_s1_byteenable(4'b_1111),
		  
	.onchip_memory6_0_s1_address(s_address[5]),     //  onchip_memory2_0_s1.address
		.onchip_memory6_0_s1_clken(1'b1),       //                     .clken
		.onchip_memory6_0_s1_chipselect(1'b1),  //                     .chipselect
		.onchip_memory6_0_s1_write(s_write[5]),       //                     .write
		.onchip_memory6_0_s1_readdata(s_readdata[5]),    //                     .readdata
		.onchip_memory6_0_s1_writedata(s_writedata[5]),   //                     .writedata
		.onchip_memory6_0_s1_byteenable(4'b_1111),
	
	.onchip_memory7_0_s1_address(s_address[6]),     //  onchip_memory2_0_s1.address
		.onchip_memory7_0_s1_clken(1'b1),       //                     .clken
		.onchip_memory7_0_s1_chipselect(1'b1),  //                     .chipselect
		.onchip_memory7_0_s1_write(s_write[6]),       //                     .write
		.onchip_memory7_0_s1_readdata(s_readdata[6]),    //                     .readdata
		.onchip_memory7_0_s1_writedata(s_writedata[6]),   //                     .writedata
		.onchip_memory7_0_s1_byteenable(4'b_1111),
		
	.onchip_memory8_0_s1_address(s_address[7]),     //  onchip_memory2_0_s1.address
		.onchip_memory8_0_s1_clken(1'b1),       //                     .clken
		.onchip_memory8_0_s1_chipselect(1'b1),  //                     .chipselect
		.onchip_memory8_0_s1_write(s_write[7]),       //                     .write
		.onchip_memory8_0_s1_readdata(s_readdata[7]),    //                     .readdata
		.onchip_memory8_0_s1_writedata(s_writedata[7]),   //                     .writedata
		.onchip_memory8_0_s1_byteenable(4'b_1111),
		
	.onchip_memory9_0_s1_address(s_address[8]),     //  onchip_memory2_0_s1.address
		.onchip_memory9_0_s1_clken(1'b1),       //                     .clken
		.onchip_memory9_0_s1_chipselect(1'b1),  //                     .chipselect
		.onchip_memory9_0_s1_write(s_write[8]),       //                     .write
		.onchip_memory9_0_s1_readdata(s_readdata[8]),    //                     .readdata
		.onchip_memory9_0_s1_writedata(s_writedata[8]),   //                     .writedata
		.onchip_memory9_0_s1_byteenable(4'b_1111),
		
	.onchip_memory10_0_s1_address(s_address[9]),     //  onchip_memory2_0_s1.address
		.onchip_memory10_0_s1_clken(1'b1),       //                     .clken
		.onchip_memory10_0_s1_chipselect(1'b1),  //                     .chipselect
		.onchip_memory10_0_s1_write(s_write[9]),       //                     .write
		.onchip_memory10_0_s1_readdata(s_readdata[9]),    //                     .readdata
		.onchip_memory10_0_s1_writedata(s_writedata[9]),   //                     .writedata
		.onchip_memory10_0_s1_byteenable(4'b_1111),
		  
	// Ethernet
	.hps_io_hps_io_gpio_inst_GPIO35	(HPS_ENET_INT_N),
	.hps_io_hps_io_emac1_inst_TX_CLK	(HPS_ENET_GTX_CLK),
	.hps_io_hps_io_emac1_inst_TXD0	(HPS_ENET_TX_DATA[0]),
	.hps_io_hps_io_emac1_inst_TXD1	(HPS_ENET_TX_DATA[1]),
	.hps_io_hps_io_emac1_inst_TXD2	(HPS_ENET_TX_DATA[2]),
	.hps_io_hps_io_emac1_inst_TXD3	(HPS_ENET_TX_DATA[3]),
	.hps_io_hps_io_emac1_inst_RXD0	(HPS_ENET_RX_DATA[0]),
	.hps_io_hps_io_emac1_inst_MDIO	(HPS_ENET_MDIO),
	.hps_io_hps_io_emac1_inst_MDC		(HPS_ENET_MDC),
	.hps_io_hps_io_emac1_inst_RX_CTL	(HPS_ENET_RX_DV),
	.hps_io_hps_io_emac1_inst_TX_CTL	(HPS_ENET_TX_EN),
	.hps_io_hps_io_emac1_inst_RX_CLK	(HPS_ENET_RX_CLK),
	.hps_io_hps_io_emac1_inst_RXD1	(HPS_ENET_RX_DATA[1]),
	.hps_io_hps_io_emac1_inst_RXD2	(HPS_ENET_RX_DATA[2]),
	.hps_io_hps_io_emac1_inst_RXD3	(HPS_ENET_RX_DATA[3]),

	// Flash
	.hps_io_hps_io_qspi_inst_IO0	(HPS_FLASH_DATA[0]),
	.hps_io_hps_io_qspi_inst_IO1	(HPS_FLASH_DATA[1]),
	.hps_io_hps_io_qspi_inst_IO2	(HPS_FLASH_DATA[2]),
	.hps_io_hps_io_qspi_inst_IO3	(HPS_FLASH_DATA[3]),
	.hps_io_hps_io_qspi_inst_SS0	(HPS_FLASH_NCSO),
	.hps_io_hps_io_qspi_inst_CLK	(HPS_FLASH_DCLK),

	// Accelerometer
	.hps_io_hps_io_gpio_inst_GPIO61	(HPS_GSENSOR_INT),

	//.adc_sclk                        (ADC_SCLK),
	//.adc_cs_n                        (ADC_CS_N),
	//.adc_dout                        (ADC_DOUT),
	//.adc_din                         (ADC_DIN),

	// General Purpose I/O
	.hps_io_hps_io_gpio_inst_GPIO40	(HPS_GPIO[0]),
	.hps_io_hps_io_gpio_inst_GPIO41	(HPS_GPIO[1]),

	// I2C
	.hps_io_hps_io_gpio_inst_GPIO48	(HPS_I2C_CONTROL),
	.hps_io_hps_io_i2c0_inst_SDA		(HPS_I2C1_SDAT),
	.hps_io_hps_io_i2c0_inst_SCL		(HPS_I2C1_SCLK),
	.hps_io_hps_io_i2c1_inst_SDA		(HPS_I2C2_SDAT),
	.hps_io_hps_io_i2c1_inst_SCL		(HPS_I2C2_SCLK),

	// Pushbutton
	.hps_io_hps_io_gpio_inst_GPIO54	(HPS_KEY),

	// LED
	.hps_io_hps_io_gpio_inst_GPIO53	(HPS_LED),

	// SD Card
	.hps_io_hps_io_sdio_inst_CMD	(HPS_SD_CMD),
	.hps_io_hps_io_sdio_inst_D0	(HPS_SD_DATA[0]),
	.hps_io_hps_io_sdio_inst_D1	(HPS_SD_DATA[1]),
	.hps_io_hps_io_sdio_inst_CLK	(HPS_SD_CLK),
	.hps_io_hps_io_sdio_inst_D2	(HPS_SD_DATA[2]),
	.hps_io_hps_io_sdio_inst_D3	(HPS_SD_DATA[3]),

	// SPI
	.hps_io_hps_io_spim1_inst_CLK		(HPS_SPIM_CLK),
	.hps_io_hps_io_spim1_inst_MOSI	(HPS_SPIM_MOSI),
	.hps_io_hps_io_spim1_inst_MISO	(HPS_SPIM_MISO),
	.hps_io_hps_io_spim1_inst_SS0		(HPS_SPIM_SS),

	// UART
	.hps_io_hps_io_uart0_inst_RX	(HPS_UART_RX),
	.hps_io_hps_io_uart0_inst_TX	(HPS_UART_TX),

	// USB
	.hps_io_hps_io_gpio_inst_GPIO09	(HPS_CONV_USB_N),
	.hps_io_hps_io_usb1_inst_D0		(HPS_USB_DATA[0]),
	.hps_io_hps_io_usb1_inst_D1		(HPS_USB_DATA[1]),
	.hps_io_hps_io_usb1_inst_D2		(HPS_USB_DATA[2]),
	.hps_io_hps_io_usb1_inst_D3		(HPS_USB_DATA[3]),
	.hps_io_hps_io_usb1_inst_D4		(HPS_USB_DATA[4]),
	.hps_io_hps_io_usb1_inst_D5		(HPS_USB_DATA[5]),
	.hps_io_hps_io_usb1_inst_D6		(HPS_USB_DATA[6]),
	.hps_io_hps_io_usb1_inst_D7		(HPS_USB_DATA[7]),
	.hps_io_hps_io_usb1_inst_CLK		(HPS_USB_CLKOUT),
	.hps_io_hps_io_usb1_inst_STP		(HPS_USB_STP),
	.hps_io_hps_io_usb1_inst_DIR		(HPS_USB_DIR),
	.hps_io_hps_io_usb1_inst_NXT		(HPS_USB_NXT)
);


endmodule

module matrixmul(
	input signed [26:0] xo, yo, zo, sin, cos,
	input  [1:0] sel,
	output signed [26:0] xn, yn, zn
	);
       
	wire signed [26:0] m0;
	wire signed [26:0] m1;
	wire signed [26:0] m2;   
	wire signed [26:0] m3;
	wire signed [26:0] a0;
	wire signed [26:0] a1;
  

	
	assign a0 = (sel[1])?xo:(sel[0]?zo:yo);
	assign a1 = (sel[1])?yo:(sel[0]?xo:zo);	 

	signed_mult mul0(
		.out(m0),
		.a(a0),
		.b(sin)
	);
	signed_mult mul1(
		.out(m1),
		.a(a1),
		.b(sin)
	);
	signed_mult mul2(
		.out(m2),
		.a(a0),
		.b(cos)
	);
	signed_mult mul3(
		.out(m3),
		.a(a1),
		.b(cos)
	);

	assign xn = (sel[1])?(m2-m1):(sel[0]?(m0+m3):(xo));
	assign yn = (sel[1])?(m0+m3):(sel[0]?(yo):(m2-m1));
	assign zn = (sel[1])?(zo):(sel[0]?(m2-m1):(m0+m3));
endmodule

module signed_mult (out, a, b);
	output 	signed  [26:0]	out;
	input 	signed	[26:0] 	a;
	input 	signed	[26:0] 	b;
	// intermediate full bit length
	wire 	signed	[53:0]	mult_out;
	assign mult_out = a * b;
	// // select bits for 12.15 fixed point
	
	assign out = {mult_out[53], mult_out[40:15]};
endmodule
